/bin/rm -rf output
/bin/rm -f first/module-info.java
/bin/rm -f second/module-info.java

mkdir -p output/classes
mkdir -p output/lib

javac -d output/classes `find first -name *.java`
jar -c -f output/lib/first.jar -C output/classes .
/bin/rm -rf output/classes

javac -d output/classes -classpath output/lib/first.jar `find second -name *.java`
jar -c -f output/lib/second.jar -C output/classes .
/bin/rm -rf output/classes

#code that runs in the classpath belongs to the unnamed module
#old code that runs in the modulepath belongs to an automatic module
#code with module descriptors that runs in the modulepath belongs 
#to an explicitly named module


echo "running old code in the classpath"
java -classpath output/lib/first.jar:output/lib/second.jar \
  com.agiledeveloper.second.Second

echo ""

echo "running old code in the modulepath"
java -p output/lib -m second/com.agiledeveloper.second.Second

echo "compling modules"
cp first-module-info.txt first/module-info.java
cp second-module-info.txt second/module-info.java

javac -d output/classes `find first -name *.java`
jar -c -f output/lib/first.jar -C output/classes .
/bin/rm -rf output/classes

javac -d output/classes -p output/lib/first.jar `find second -name *.java`
jar -c -f output/lib/second.jar -C output/classes .
/bin/rm -rf output/classes


echo ""
echo "running module in the classpath"
java -classpath output/lib/first.jar:output/lib/second.jar \
  com.agiledeveloper.second.Second

echo ""
echo "running module in the modulepath"
java -p output/lib \
  -m com.agiledeveloper.thesecond/com.agiledeveloper.second.Second


