import java.util.*;
import static java.util.stream.Collectors.*;

public class Sample {
  public static void main(String[] args) {
    var numbers = List.of(10, 20, 31, 40, 51, 60, 70, 90);

    var result1 = numbers.stream()
      .filter(number -> number > 50)
      .map(number -> number * 2)
      .collect(toList()); //mutable list, not desirable

    result1.add(77);

    System.out.println(result1);

    var result2 = numbers.stream()
      .filter(number -> number > 50)
      .map(number -> number * 2)
      .collect(toUnmodifiableList()); //immutable list, not desirable

    //result2.add(77); //ERROR

    System.out.println(result2);

    var result3 = numbers.stream()
      .filter(number -> number > 50)
      .map(number -> number * 2)
      .toList(); //immutable list, not desirable

    //result3.add(77); //ERROR

    System.out.println(result3);
  }
}

//Avoid using Collectors.toList() moving forward.
//Prefer toList() directly on the stream.
//And for set, etc. use the toUnmodifiable... version

