import java.lang.foreign.*;
import java.lang.invoke.*;
import static java.lang.foreign.ValueLayout.*;

public class Sample {
  public static void main(String[] args) throws Throwable {
    double value = 16.0;

    var symbolLookup = Linker.nativeLinker().defaultLookup();

    var methodHandle = Linker.nativeLinker().downcallHandle(
      symbolLookup.find("sqrt").orElseThrow(),
      FunctionDescriptor.of(JAVA_DOUBLE, JAVA_DOUBLE));

    var result = (double) methodHandle.invoke(value);

    System.out.println(result);
  }
}
